//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnPingClick(TObject *Sender)
{
   btnPing->Enabled=false;
   Memo1->Lines->Add("Pinging \""+edtIP->Text+"\"...");
   try
   {
      IdIcmpClient1->ReceiveTimeout=1000;
      IdIcmpClient1->Host=edtIP->Text;
      for(int i=0; i<4; i++)
      {
         try
         {
            IdIcmpClient1->Ping();
            Application->ProcessMessages();
         }
         catch(Exception &e)
         {
            Memo1->Lines->Add("Request timed out.");
         }
      }
   }
   __finally
   {
      btnPing->Enabled=true;
   }
   Memo1->Lines->Add("End!");
   Memo1->Lines->Add("");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::IdIcmpClient1Reply(TComponent *ASender,
      const TReplyStatus &AReplyStatus)
{
   AnsiString szReport;
   if(AReplyStatus.FromIpAddress=="0.0.0.0" && AReplyStatus.TimeToLive==0)
   {
      szReport="Request timed out.";
   }
   else
   {
      if(AReplyStatus.MsRoundTripTime==0)
      {
         szReport.sprintf("Reply from %s: bytes=%d time<1ms TTL=%d",
            AReplyStatus.FromIpAddress, AReplyStatus.BytesReceived,
            AReplyStatus.TimeToLive);
      }
      else
      {
         szReport.sprintf("Reply from %s: bytes=%d time=%dms TTL=%d",
            AReplyStatus.FromIpAddress, AReplyStatus.BytesReceived,
            AReplyStatus.MsRoundTripTime, AReplyStatus.TimeToLive);
      }
   }
   Memo1->Lines->Add(szReport);
}
//---------------------------------------------------------------------------
 